
#ifndef __creaWx_h__INCLUDED__
#define __creaWx_h__INCLUDED__

//===========================================================================
// Wx headers
#ifdef USE_WXWIDGETS
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"
#include <wx/datetime.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#ifdef __WXGTK__
# include <locale.h>
#endif //__WXGTK__
// EO Wx headers
//===========================================================================
#else // USE_WXWIDGETS
// define wxWindow as void hence wxWindow* are void*
typedef void wxWindow;
#endif // EO USE_WXWIDGETS
//===========================================================================

//===========================================================================
#ifdef USE_WXWIDGETS

#if defined(_WIN32) 

//  How to have a Console and wxWidgets
//  http://www.wxwidgets.org/wiki/index.php/MSVC_Setup_Guide
//   In Visual C++ 6 (7 should be similar), to create an application that is both a console application 
//  (cout's to the console are visible) and has a wxWidgets GUI, 
//  you need to use the linker option "/subsystem:console" and the following code:

#define CREA_WXMAIN_WITH_CONSOLE					\
  int main(int argc, char* argv[])					\
  {									\
    return WinMain(::GetModuleHandle(NULL), NULL,			\
		   ::GetCommandLine(), SW_SHOWNORMAL);			\
  }									

#else // defined(_WIN32) 

#define CREA_WXMAIN_WITH_CONSOLE

#endif // defined(_WIN32) 

#include <string>

namespace crea
{
  //==================================================================
  /// Conversion std::string to wxString 
  inline wxString std2wx(const std::string& s) {
    wxString wx;
    const char* my_string=s.c_str();
    wxMBConvUTF8 *wxconv= new wxMBConvUTF8();
    wx=wxString(wxconv->cMB2WC(my_string),wxConvUTF8);
    delete wxconv;
    // test if conversion works of not. In case it fails convert from Ascii
    if(wx.length()==0)
      wx=wxString(wxString::FromAscii(s.c_str()));
    return wx;
  }
  //==================================================================

  //==================================================================
  /// Conversion wxString to std::string
  inline std::string wx2std(const wxString& s){
    std::string s2;
    if(s.wxString::IsAscii()) {
      s2=s.wxString::ToAscii();
    } else {
      const wxWX2MBbuf tmp_buf = wxConvCurrent->cWX2MB(s);
      const char *tmp_str = (const char*) tmp_buf;
      s2=std::string(tmp_str, strlen(tmp_str));
    }
    return s2;
  }
  //==================================================================
}

#endif // EO USE_WXWIDGETS

#endif
